subroutine TDMA(N,aE,aW,aP,b,M1,M2,T)
!    integer M1,M2,N
!    parameter (N=10, Np1=N+1)
    integer, intent(in) :: N,M1,M2
!    real, dimension(Np1), intent(in) ::aE,aW,aP,b
!    real, dimension(Np1), intent(out) ::T
!    real, dimension(Np1) ::Q,P
    real, dimension(N), intent(in) :: aE, aW, aP, b
    real, dimension(N), intent(out) :: T
!
!   Local Variables Decleration
!
    real, dimension(N) :: Q, P
    integer:: I, Np1
    real:: den
!    
    !allocate (aE(N), aW(N), aP(N), b(N), T(N), Q(N), P(N))    
!    
!Solution
    P(M1) = aE(M1)/aP(M1)
    Q(M1) = b(M1)/aP(M1)
    do I=M1+1,M2
        den = aP(I)-aW(I)*P(I-1)
        P(I) = aE(I)/den
        Q(I) = (b(I)+Q(I-1)*aW(I))/den
    enddo
    T(M2) = Q(M2)
    do I=M2-1,M1,-1
        T(I) = P(I)*T(I+1)+Q(I)
    enddo
end subroutine TDMA
    
    